/* Teknisa - Tecnologia em Informtica

Nome:
  3941_CDPFUNO.SQL

Descrio:
  Funo para retornar o custo do produto baseado apenas nas matrias primas retiradas recursivamente.
  No contm material de embalagem, semiacabados, e nem perda.

Criao:
  22/08/2016 - Srgio Pow

@..\Sql\End_Conv\Oracle\3941_CDPFUNO.SQL
*/

CREATE OR REPLACE FUNCTION CUS_SEMIACABADO_MP( 
   P_CDFILIAL     IN ORDPRODUCAO.CDFILIAL%TYPE, 
   P_CDPRODUTO    IN ORDPRODUCAO.CDPRODUTO%TYPE, 
   P_NRLOTEESTQ   IN ORDPRODUCAO.NRLOTEESTQ%TYPE, 
   P_NRSUBLOTE    IN ORDPRODUCAO.NRSUBLOTE%TYPE,
   P_QTAPRODPREOP IN ORDPRODUCAO.QTAPRODPREOP%TYPE) RETURN FLOAT IS 
 
   V_VRTOTAL   FLOAT; 
BEGIN 
   BEGIN 
      SELECT SUM(
                ROUND(
                   DECODE(IE.IDSEMIACETAP, 'N',
                             (QTPREVI_MATPRIMA(OP.CDFILIAL, OP.CDPRODUTO, OP.CDPROCFABRIC, RE.CDETAPAPROD, IT.CDPRODUTO, P_QTAPRODPREOP) * 
                             CUSTO_PRODUTO_LCEST(RE.CDFILIAL, IT.CDPRODUTO, '03' , SYSDATE, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE)),
                             
                             CUS_SEMIACABADO_MP(IT.CDFILIAL, IT.CDPRODUTO, IT.NRLOTEESTQ, IT.NRSUBLOTE, IT.QTLANCTOEST)
                          ),2
                      )
                ) AS VRTOTAL
        INTO V_VRTOTAL
        FROM ORDPRODUCAO OP, RETIRADAESTO RE, ITLANCTOEST IT, PRODUTO PR, INSUMETAPA IE, ITEMRETIEST IR
       WHERE (OP.IDSITORDPROD  = '3'           )
         AND (RE.CDFILIAL     = OP.CDFILIAL    )
         AND (RE.NRORDPROD    = OP.NRORDPROD   )
         AND (RE.NRSUBORDPROD = OP.NRSUBORDPROD)
         AND (RE.CDFILIAL     = IT.CDFILIAL    )
         AND (RE.NRLANCESTQ   = IT.NRLANCESTQ  )
         AND (PR.CDPRODUTO    = IT.CDPRODUTO   )
         AND (OP.CDFILIAL     = P_CDFILIAL     )
         AND (OP.CDPRODUTO    = P_CDPRODUTO    )
         AND (OP.NRLOTEESTQ   = P_NRLOTEESTQ   )
         AND (OP.NRSUBLOTE    = P_NRSUBLOTE    )
         AND (OP.CDFILIAL     = IE.CDFILIAL    )
         AND (OP.CDPRODUTO    = IE.CDPRODUTO   )
         AND (OP.CDPROCFABRIC = IE.CDPROCFABRIC)
         AND (RE.CDETAPAPROD  = IE.CDETAPAPROD )
         AND (IT.CDPRODUTO    = IE.CDPRODINSUMO)
         AND IE.CDTIPOINSU NOT IN (
                                   SELECT CDTIPOINSU
                                     FROM TIPOINSU
                                    WHERE (IDTPMATERIAL = 'E')
                                  )
         AND (RE.CDFILIAL     = IR.CDFILIAL    )
         AND (RE.NRRETEST     = IR.NRRETEST    )
         AND IR.CDTIPORETI NOT IN (
                                   SELECT CDTIPORETI
                                     FROM TIPORETI
                                    WHERE (CDFUNCUSTO = '099')
                                  )
      ORDER BY RE.CDFILIAL, RE.NRORDPROD, RE.NRSUBORDPROD, IT.CDPRODUTO;
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN  
      V_VRTOTAL := 0; 
   END; 
 
   RETURN(V_VRTOTAL); 
END; 

/

-- VERSAO --
BEGIN ATUVEROBJ('CUS_SEMIACABADO_MP','6.05.xxx'); END;
/