IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CONSULTA_ESTOQUE_ORE' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CONSULTA_ESTOQUE_ORE
GO

CREATE FUNCTION CONSULTA_ESTOQUE_ORE (@P_FILIAL      VARCHAR(04),
                                      @P_PRODUTO     VARCHAR(10),                               
                                      @P_IDORCAENCO  VARCHAR(01),
                                      @P_ALMOXARIFE  VARCHAR(06),
                                      @P_LOCALESTOQ  VARCHAR(06),
                                      @P_LOTEESTQ    VARCHAR(20),
                                      @P_SUBLOTE     VARCHAR(04))RETURNS NUMERIC(15, 5)
AS 
BEGIN
   DECLARE @V_IDESTVERIFI VARCHAR(20);
   DECLARE @V_QTDEESTO    DOUBLE PRECISION;
   DECLARE @V_VALRESTO    DOUBLE PRECISION;
   DECLARE @V_VALRBRUT    DOUBLE PRECISION;
   DECLARE @V_CDPRODMOVI  VARCHAR(10);
   DECLARE @V_DATA        DATETIME;

   IF @P_IDORCAENCO = 'O' BEGIN
      /*BUSCA O PARAMETRO DO ORAMENTO */
      SELECT @V_IDESTVERIFI = MAX(IDESTVERIFIORCA)          
        FROM PARAMORCAEVE;
      
      IF @V_IDESTVERIFI = '' BEGIN
         SET @V_IDESTVERIFI = 'ESTOQUEATUAL';
      END;
   END
   ELSE BEGIN
      /*BUSCA O PARAMETRO DA ENCOMENDA */
      SELECT @V_IDESTVERIFI = MAX(IDESTVERIFIENCO)
        FROM PARAMORCAEVE;
      IF @V_IDESTVERIFI = '' BEGIN
         SET @V_IDESTVERIFI = 'ESTOQUEATUAL';
      END;
   END;
   SET @V_DATA = GETDATE() + 1;
   
   IF @V_IDESTVERIFI = 'ESTOQUEATUAL'  BEGIN
      EXEC CONSULTA_POSICAO @P_FILIAL, @P_PRODUTO, @V_DATA, 
                            @P_ALMOXARIFE, @P_LOCALESTOQ, @P_LOTEESTQ, 
                            @P_SUBLOTE, 'N', @V_QTDEESTO OUTPUT, @V_VALRESTO OUTPUT, @V_VALRBRUT OUTPUT;      
   END
   ELSE BEGIN
      SELECT @V_CDPRODMOVI = MAX(CDPRODESTO)        
        FROM PRODUTO
       WHERE CDPRODUTO = @P_PRODUTO;
      IF @V_CDPRODMOVI = '' BEGIN
        SET @V_CDPRODMOVI = NULL;
      END;
      
     
      SELECT @V_QTDEESTO = MAX(QTLANCTOEST)           
        FROM ITLANCTOEST
       WHERE CDFILIMOVI = @P_FILIAL
         AND CDPRODMOVI = @V_CDPRODMOVI
         AND CDALMOXARIFE = @P_ALMOXARIFE
         AND CDLOCALESTOQ = @P_LOCALESTOQ
         AND NRLOTEESTQ = @P_LOTEESTQ
         AND NRSUBLOTE = @P_SUBLOTE
         AND IDTIPOMOVI = '1'
         AND DTLANCMOVI = (SELECT MAX(DTLANCMOVI)
                             FROM ITLANCTOEST
                            WHERE CDFILIMOVI = @P_FILIAL
                              AND CDPRODMOVI = @V_CDPRODMOVI
                              AND CDALMOXARIFE = @P_ALMOXARIFE
                              AND CDLOCALESTOQ = @P_LOCALESTOQ
                              AND NRLOTEESTQ = @P_LOTEESTQ
                              AND NRSUBLOTE = @P_SUBLOTE
                              AND IDTIPOMOVI = '1'
                              AND DTLANCMOVI <= GETDATE());    
      IF @V_QTDEESTO = '' BEGIN 
        SET @V_QTDEESTO = 0;
      END;      
   END;
   RETURN (@V_QTDEESTO);
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONSULTA_ESTOQUE_ORE','5.45.000';
GO